//
// Copyright (C) 2004 Andras Varga
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//


#include "QueueWithQoS.h"


void QueueWithQoS::initialize()
{
    AbstractQueue::initialize();

    delay = par("procDelay");
    qosHook = check_and_cast<EnqueueHook *>(createOne(par("qosBehaviorClass")));
    qosHook->setModule(this);
}


void QueueWithQoS::arrival(cMessage *msg)
{
    qosHook->enqueue(msg, queue);
}

cMessage *QueueWithQoS::arrivalWhenIdle(cMessage *msg)
{
    return qosHook->dropIfNotNeeded(msg);
}

simtime_t QueueWithQoS::startService(cMessage *msg)
{
    return delay;
}

